Multiple IPv4 address and port number - IPv6 address mapping encapsulation (M4P6E)
Naoki Matsuhira
WIDE Project
Japan
naoki.matsuhira@gmail.com
4 April 2022
IPv6
Draft
This document specifies Multiple IPv4 address and port number - IPv6 address mapping encapulation (M4P6E) specification.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in RFC 2119.

Introduction
This document provides Multiple IPv4 address and port number - IPv6 address mapping encapulation (M4P6E) base specification.
M4P6E provide IPv4 address sharing function without Network Address Translation (NAT). M4P6E require IPv6 network.

Architecture of M4P6E
Figure 1 shows M4P6E address architecture. M4P6E address consists four parts, M4P6E prefix, IPv4 network plane ID, IPv4 address, and Port number.

|                      |                |                |         |
|    80 - m bits       |   m bits       |    32 bits     | 16 bits |
+----------------------+----------------+----------------+----:----+
|  M4P6E prefix        | IPv4 network   |  IPv4 address  |  port   |
|                      | plane ID       |                | number  |
+----------------------+----------------+----------------+----:----+
|<--------------- Locator (128 -n bits  )-------------------->:<-->|
|                                                             : ID |
|                                                            (n bits)

In M4P6E, boundary of locator and identifier is in port number part, that mean, M4P6E use upper part of port number as locator, and lower part of port number as identifier.

M4P6E address format
Figure 2 show a example of M4P6E address format. In this example, 16bits IPv4 network plane ID is used, that provide 65535 IPv4 network plane.

 | 3 |      45bits      |  16bits |  16 bits|   32bits   | 16 bits |
 +---+------------------+---------+---------+------------+---------+
 |001|  routing prefix  |subnet id| plane ID|IPv4 address| Port #  |
 +---+------------------+---------+----------------------+---------+

Using M4P6E in client server environments

Client environments
Figure 3 shows a example of M4P6E usage in client environments. In this document, NAPT is IPv4 - IPv4 Netowrk address and port number translator. Coopetation with NAPT, M4P6E provide IPv4 address sharing with different users.

 +--------------+
 |              |    +---------+  +--------+     +---------+
 |              +----|  M4P6E  |--|  NAPT  |--+--| Clients |
 |              |    +---------+  +--------+  |  +---------+
 |              |                             |  +---------+
 |              |                             +--| Clients |
 | Backbone     |                             |  +---------+
 |              |                             :
 |              |                             |  +---------+
 |   Network    |                             +--| Clients |
 |              |                                +---------+
 |              |
 |              |    +---------+  +--------+     +---------+
 |              +----|  M4P6E  |--|  NAPT  |--+--| Clients |
 |              |    +---------+  +--------+  |  +---------+
 |              |                             |  +---------+
 |              |                             +--| Clients |
 |              |                             |  +---------+
 |              |                             :
 |              |                             |  +---------+
 |              |                             +--| Clients |
 |              |                                +---------+
 :              :        :             :              :
 |              |    +---------+  +--------+     +---------+
 |              +----|  M4P6E  |--|  NAPT  |--+--| Clients |
 |              |    +---------+  +--------+  |  +---------+
 |              |                             |  +---------+
 |              |                             +--| Clients |
 |              |                             |  +---------+
 |              |                             :
 |              |                             |  +---------+
 |              |                             +--| Clients |
 |              |                                +---------+
 +--------------+

Server environments
Figure 4 shows an example of M4P6E usage in server environments. In this example, server terminate M4P6E tunnel. This case, Server require at least one port number per server, that mean, 128bits host route advertise for server access via IPv4. This case, full access is provided via IPv6.

 +--------------+
 |              |    +------------+
 |              +----|Server with |
 |              |    |M4P6E       |
 | Backbone     |    |function    |
 |              |    +------------+
 |              |    +------------+
 |  Network     +----|Server with |
 |              |    |M4P6E       |
 |              |    |function    |
 |              |    +------------+
 :              :           :
 |              |    +------------+
 |              +----|Server with |
 |              |    |M4P6E       |
 |              |    |function    |
 |              |    +------------+
 +--------------+

Data Center Environments
Figure 5 shows an example of M4P6E usage in Data Center environments. In this example, M4P6E is used only in Data Center Backend Network closely. Client which is connected via backbone network does not know the exists of M4P6E. M4P6E can provide at least one port number per server, this case, 128bits host route is advertised, however this route in advertised only in data center backbone network. Ofcource, IPv6 address may allocated to the server, so full access is provided via IPv6.
                             .
 +--------+                  .        +-------+
 |        |  +-------+       .        |       | +-----------------+
 |        +--+       |       .        |       |-|  Server w/M4P6E |
 |        |  | Data  |       .        | Data  | +-----------------+
 |Backbone+--+Center |  +----------+  |Center | +-----------------+
 |        |  |       +--|   M4P6E  |--+       |-|  Server w/M4P6E |
 |        |  |Front  |  +----------+  |Backend| +-----------------+
 |Network |  |Network|       .        |Network| +-----------------+
 |        |  |       |  +----------+  |       |-|  Server w/M4P6E |
 |        |  |       +--|   M4P6E  |--+       | +-----------------+
 |        |  |       |  +----------+  |       | +-----------------+
 :        :  :       :       .        |       |-|  Server w/M4P6E |
 |        |  |       |       .        |       | +-----------------+
 |        |  |       |       .        |       |         :
 |        |  |       |       .        |       | +-----------------+
 |        |  |       |       .        |       |-|  Server w/M4P6E |
 |        |  +-------+       .        |       | +-----------------+
 +--------+                  .        +-------+
                             .
 -Normal IPv4 communication->.<----- M4P6E ----->
                             .     communication
                             .
 ------- Normal IPv6 communication ----------------->
                             .

Port Number Issue
M4P6E require port number of transport layer. M4P6E can not support ICMPv4. The function provided by ICMPv4 does not work in M4P6E environments, such as Path MTU Discovery, ping command, etc.
M4P6E can not also support IPv4 IPsec ESP because transport header is encrypted.

IANA Considerations
This document makes no request of IANA.
Note to RFC Editor: this section may be removed on publication as an RFC.

Security Considerations
M4P6E use automatic tunneling technologies. Security consideration related tunneling technologies are discussed in RFC2893, RFC2267, etc.

Normative References